registerObjectType('PShip1', 'Player');
var PShip1 = Player.extend({
    className: 'PShip1',
	isFixedZ: true,
	
	u: 		0.5,
	cgroup: 1,
	
	health: 	  25,
	maxHealth: 	  50,
	armour: 	 1.5,
	attackPower: 1.0,
	attackRange: 400,
	
	heat: 		0.0,
	    
    init: function () // Modifyable
    {
		this.setRadius(25.0);
        arguments.callee.$.init.call(this); // Call super
    },
	
	damage: function(d)
	{
		this.health -= d/(d>0.0?this.armour:1.0);
		if (this.health < 0)
		{
			this.health = 0;
			canMove = false;
		}
		if (this.health > this.maxHealth)
		{
			this.heat += (this.health-this.maxHealth);
			this.health = this.maxHealth;
		}
		this.heat += d;
	},
		
    editorRender: function (c) // Modifyable - Only function called by editor
    {
        var p = c.toScr(this.getPosition());
        var r = this.getRadius();
		if (this.isFixedZ === false || IN_EDITOR === true) r *= c.z;
        drawImageAng(loadImage('game/graphics/ship.png'), p.x, p.y, r, 1.0, this.getAngle());
    },
    gameRender: function (c) // Modifyable
    {
        this.editorRender(c);
    },
    update: function ( dt ) // Modifyable
    {
		if (this.heat > 0.0)
		{
			this.heat -= 5/FPS;
			if (this.heat < 0.0)
				this.heat = 0.0;
		}
		else if (this.heat < 0.0)
		{
			this.heat += 5/FPS;
			if (this.heat > 0.0)
				this.heat = 0.0;
		}
		arguments.callee.$.update.call(this, dt);
    },
	getCollisionObj: function ()
	{
		return this.collisionObjectImage('game/graphics/ship.png');
	},
	
	moveForward: function ()
	{
		var a = this.getAngle() - Math.PI/2.0;
		var s = 25.0 / getCam().z;
		var va = new pnt(Math.cos(a)*s, Math.sin(a)*s);
		this.addVelocity(va);
		
		var p = this.getPosition();
		for (var i=1; i<=3; i++)
		{
			var s2 = -Math.random()*0.25*0.5;
			var ad = Math.random()*Math.PI/3.0-Math.PI/6.0;
			addParticle(new pnt(p.x+Math.cos(a-Math.PI+ad)*8.0/getCam().z, p.y+Math.sin(a-Math.PI+ad)*8.0/getCam().z), new pnt(Math.cos(a-Math.PI+ad)*s2, Math.sin(a-Math.PI+ad)*s2), Math.random()*4.0+2.0, rgb(0.0, 1.0, Math.random()*0.5+0.5), 0.004);
		}
	},
	moveBackward: function ()
	{
		var a = this.getAngle() - Math.PI/2.0;
		var s = -25.0 / getCam().z;
		var va = new pnt(Math.cos(a)*s, Math.sin(a)*s);
		var r = this.getRadius();
		this.addVelocity(va);
		
		var p1 = this.getPosition();
		p1 = p1.add(va.mulf((1.0/s*r*0.25)/(Math.pow(getCam().z,2.0))));
		for (var i=1; i<=2; i++)
		{
			var s2 = -Math.random()*0.125*0.5;
			var ad = Math.random()*Math.PI/3.0-Math.PI/6.0;
			var p = new pnt(Math.cos(a+Math.PI/2.0), Math.sin(a+Math.PI/2.0)); p = p.mulf(r*0.4/getCam().z).add(p1);
			addParticle(new pnt(p.x+Math.cos(a-Math.PI+ad)*2.0/getCam().z, p.y+Math.sin(a-Math.PI+ad)*2.0/getCam().z), new pnt(Math.cos(a-Math.PI+ad)*s2, Math.sin(a-Math.PI+ad)*s2), Math.random()*2.0+2.0, rgb(0.0, 1.0, Math.random()*0.5+0.5), 0.004);
			var p = new pnt(Math.cos(a-Math.PI/2.0), Math.sin(a-Math.PI/2.0)); p = p.mulf(r*0.4/getCam().z).add(p1);
			addParticle(new pnt(p.x+Math.cos(a-Math.PI+ad)*2.0/getCam().z, p.y+Math.sin(a-Math.PI+ad)*2.0/getCam().z), new pnt(Math.cos(a-Math.PI+ad)*s2, Math.sin(a-Math.PI+ad)*s2), Math.random()*2.0+2.0, rgb(0.0, 1.0, Math.random()*0.5+0.5), 0.004);
		}
	},
	turnLeft: function ()
	{
		this.addAngVelocity(-Math.PI*1.25);
	},
	turnRight: function ()
	{
		this.addAngVelocity(Math.PI*1.25);
	}
});

