registerObjectType('Enemy', 'Dynamic');
var Enemy = Dynamic.extend({
    className: 'Enemy',
	cgroup: 2,

	
	attackRange: 300,
	
	health: 0,
    
    init: function () // Modifyable
    {
		this.warpin_start = ctime();
		this.warpin_start_pos = this.getPosition();
        arguments.callee.$.init.call(this); // Call super
    },
	warpinOpacity: function ()
	{
		return Math.min(1.0, (ctime()-this.warpin_start) / 0.5);
	},
	renderWarpin: function ()
	{
		var c = getCam();
		var op = Math.min(1.0, (ctime()-this.warpin_start) / 1.0);
        var p = c.toScr(this.warpin_start_pos);
        var r = this.getRadius() * (1.0-op);
		if (this.isFixedZ === false) r *= c.z;
		if (op > 0.0)
			drawImageAng(loadImage('game/graphics/warp.png'), p.x-r*2.0, p.y-r*2.0, r*4.0, (1.0-op)*0.5, ctime()*5.0);
	},
    editorRender: function (c) // Modifyable - Only function called by editor
    {
        var p = c.toScr(this.getPosition());
        var r = this.getRadius();
		r *= c.z;
        drawImage(loadImage('mob.png'), p.x-r, p.y-r, r*2.0);
    },
    gameRender: function (c) // Modifyable
    {
        var p = c.toScr(this.getPosition());
        var r = this.getRadius();
		if (this.isFixedZ === false) r *= c.z;
        drawImage(loadImage('mob.png'), p.x-r, p.y-r, r*2.0);
    },
	renderHealthBar: function (c)
	{
		var p = c.toScr(this.getPosition());
		var h = this.health / (2.0*3.0);
        var r = this.getRadius();
		if (this.isFixedZ === false || IN_EDITOR === true) r *= c.z;
		h = Math.max(1.0, Math.round(h));
		drawBoxF(p.x - h, p.y - r - 10, p.x + h, p.y - r - 5, rgba(1,.2,.2,.5*this.warpinOpacity()));
	},
    update: function ( dt ) // Modifyable
    {
    },
	addCell: function ( worth )
	{
		var cell = new Cell(this.getPosition())
		cell.worth = worth;
		cell.updateRadius();
		cell.setPosition(cell.getPosition().add(pntFromAngle(Math.random()*Math.PI/2.0).mulf((this.getActualRadius()-cell.getActualRadius())/2.0)));
		addObject(cell);
	},
	addCells: function ( )
	{
		var worth = Math.floor(this.worth);
		
		while (worth >= 25)
		{
			worth -= 25;
			this.addCell(25);
		}
		while (worth >= 5)
		{
			worth -= 5;
			this.addCell(5);
		}
		while (worth >= 1)
		{
			worth -= 1;
			this.addCell(1);
		}
	},
	getCollisionObj: function ()
	{
		return null;
	},
});

