registerObjectType('Spaceport', 'Fixed');
var Spaceport = Fixed.extend({
    className: 'Spaceport',
	isBackground: true,
	isFixedZ: true,
    
    init: function () // Modifyable
    {
		this.setRadius(175.0);
        arguments.callee.$.init.call(this); // Call super
    },
    editorRender: function (c) // Modifyable - Only function called by editor
    {
        var p = c.toScr(this.getPosition());
        var r = this.getRadius();
        r *= c.z;
        drawImage(loadImage('game/graphics/spaceport.png'), p.x-r, p.y-r, r*2.0);
    },
    gameRender: function (c) // Modifyable
    {
        var p = c.toScr(this.getPosition());
        var r = this.getRadius();
        if (!this.isFixedZ) r *= c.z;
        drawImage(loadImage('game/graphics/spaceport.png'), p.x-r, p.y-r, r*2.0);
    },
    update: function ( dt ) // Modifyable
    {
    },
    getCollisionObj: function () // Modifyable
    {
        return null;
    }
});

