registerObjectType('Pyramid', 'Fixed');
var Pyramid = Fixed.extend({
    className: 'Pyramid',
	isFixedZ: false,
	isBackground: true,
	healT: 0.0,
	cloak: false,
	cloakf: 0.0,
	justSaved: false,
    
    init: function () // Modifyable
    {
		this.floatSeed = Math.random()*100.0;
		this.setRadius(32.0);
        arguments.callee.$.init.call(this); // Call super
    },
	cloak: function ()
	{
		this.cloaked = true;
	},
	decloak: function ()
	{
		this.cloaked = false;
	},
    editorRender: function (c) // Modifyable - Only function called by editor
    {
        var p = c.toScr(this.getPosition());
        var r = this.getRadius();
        r *= c.z;
		var pl = closestPlanet(this.getPosition());
		var dir = pl.p.sub(this.getPosition()).norm();
		var h = Math.sin(ctime()/1.25+this.floatSeed)*1.0*c.z;
        drawImageAng(loadImage('game/graphics/pyramid.png'), p.x+dir.x*h, p.y+dir.y*h, r, 1.0*(1.0-this.cloakf), dir.toAngle()-Math.PI/2.0);
		var ct = ctime();
		drawImageAng(loadImage('game/graphics/pyramid-heal.png'), p.x+dir.x*h, p.y+dir.y*h, r, this.healT*(1.0-this.cloakf), dir.toAngle()-Math.PI/2.0);
    },
    gameRender: function (c) // Modifyable
    {
		this.editorRender(c);
    },
    update: function ( dt ) // Modifyable
    {
		if (this.cloaked)
		{
			this.cloakf += 1.0/FPS;
			if (this.cloakf > 1.0) this.cloakf = 1.0;
		}
		else
		{
			this.cloakf -= 1.0/FPS;
			if (this.cloakf < 0.0) this.cloakf = 0.0;
		}
		var inRange = ship.getPosition().distance(this.getPosition()) < this.getRadius() * 0.75;
		if (inRange && ship.health < ship.maxHealth && !this.cloaked)
		{
			makeSafe();
			ship.damage(-10/FPS);
			this.healT += 1.0/FPS;
			if (this.healT > 1.0)
				this.healT = 1.0;
		}
		else
		{
			this.healT -= 1.0/FPS;
			if (this.healT < 0.0)
				this.healT = 0.0;
		}
		if (inRange && ship.health === ship.maxHealth && !this.cloaked)
		{
			if ((ctime()-lastLoad)>3.0 && this.justSaved === false)
			{
				if (objectiveCompare(curObjective, "/MISSION2/TRAVEL") >= 0)
				{
					save();
				}
			}
			this.justSaved = true;
		}
		else
			this.justSaved = false;
    },
    getCollisionObj: function () // Modifyable
    {
        return null;
    }
});

