registerObjectType('Cell', 'Enemy');
var Cell = Enemy.extend({
    className: 'Cell',
	isFixedZ: true,
	r: 		5.0,
	mass: 	0.0001,
    
    init: function () // Modifyable
    {
        arguments.callee.$.init.call(this); // Call super
		ebind("collision", this, this.collision, this);
		this.tstart = Math.random()*Math.PI;
    },
	collision: function(e)
	{
		if (e.obj && e.obj.className && e.obj.className === "PShip1")
		{
			playerMoney += this.worth;
			removeObject(this);
			ship.addVelocity(e.im);
		}
	},
    editorRender: function (c) // Modifyable - Only function called by editor
    {
        var p = c.toScr(this.getPosition());
        var r = this.getRadius()*2.0;
        drawImage(loadImage('game/graphics/cell1.png'), p.x-r, p.y-r, r*2.0, 0.5);
		drawImage(loadImage('game/graphics/cell2.png'), p.x-r, p.y-r, r*2.0, 0.75*(Math.sin(ctime()*Math.PI+this.tstart)*0.5+0.5));
    },
	updateRadius: function()
	{
		if (this.worth === 1)
			this.setRadius(5/1.0);
		else if (this.worth === 5)
			this.setRadius(7.5/1.0);
		else if (this.worth === 25)
			this.setRadius(12.5/1.0);
	},
    gameRender: function (c) // Modifyable
    {
		this.editorRender(c);
    },
    update: function ( dt ) // Modifyable
    {
		this.setVelocity(new pnt(0,0));
    },
    getCollisionObj: function () // Modifyable
    {
        return this.collisionObjectCircle();
    }
});

