registerObjectType('PlasmaCharge', 'Projectile');
var PlasmaCharge = Projectile.extend({
    className: 'PlasmaCharge',
	isFixedZ: true,
	clr: rgb(0,1,1),
	mass: 0.0005,
	health: 5.0,
	speed: 1500.0,
	tick: 0,
	r: 5.0,
    
    init: function () // Modifyable
    {
        arguments.callee.$.init.call(this); // Call super
    },
    editorRender: function (c) // Modifyable - Only function called by editor
    {
        var p = c.toScr(this.getPosition());
        var r = this.getRadius();
		drawCircleFG(p.x, p.y, 0.0, this.clr, r*1.5, rgba(0.0,0.0,0.0,0.0));
    },
    gameRender: function (c) // Modifyable
    {
		this.editorRender(c);
    },
    update: function ( dt ) // Modifyable
    {
		//this.tick = (this.tick+1)%2;
		if (this.tick === 0)
		{
			var r = Math.random()*this.getRadius()*0.5;
			addParticle(this.getPosition(), this.getVelocity(), r, this.clr, 0.1);
		}
		arguments.callee.$.update.call(this, dt);
    },
    getCollisionObj: function () // Modifyable
    {
        return this.collisionObjectCircle();
    }
});

