// Scripting API

var global_event = {id:-1};

var __bound = {
    
};

var __estack = [];

function epush()
{
    __estack.push(__bound);
    __bound = {};
}

function epop()
{
    __bound = __estack.splice(__estack.length-1, 1);
}

function ebind(e, ob, fnf, fnt)
{
    if (!__bound[e])
        __bound[e] = {};
    if (!__bound[e][ob.id])
        __bound[e][ob.id] = [];
    __bound[e][ob.id].push( [ fnf, fnt ] )
}

function eunbind(e, ob, fnf, fnt)
{
    if (!__bound[e])
    {
        return;
    }
    if (!__bound[e][ob.id])
    {
        return;
    }
    var lst = __bound[e][ob.id];
    for (var i=0; i<lst.length; i++)
        if (lst[i].fnf == fnf && lst[i].fnt == fnt)
        {
            lst.splice(i,1);
            if (lst.length == 0)
                delete __bound[e][ob.id];
            return;
        }
}

function eunbind_id(obid)
{
	for (var e in __bound)
	{
		var any = 1;
		while (any === 1)
		{
			any = 0;
			for (var id in __bound[e])
			{
				if (obid === id)
				{
					delete __bound[e][id];
					any = 1;
					break;
				}
			}
		}
	}
}

function etrigger(e, obid, args)
{
    if (__bound[e])
        if (__bound[e][obid])
            for (var i=0; i<__bound[e][obid].length; i++)
				if (__bound[e][obid][i][0])
					__bound[e][obid][i][0].apply(__bound[e][obid][i][1], args);
}

var __graphics = {};
var __gfx_lastmod = {};
var __gfx_lmodct = {};
var __gfx_lmct1 = {};
function loadImage(file)
{
    if (__graphics[file] || __graphics[file] === 0)
	{
		var lmod = __gfx_lastmod[file];
		if (ctime()-__gfx_lmct1[file] > 2.0)
		{
			__gfx_lmct1[file] = ctime();
			lmod = _flastmod(file);
		}
		if (lmod !== __gfx_lastmod[file])
		{
			__gfx_lmct1[file] = ctime;
			__gfx_lastmod[file] = lmod;
			__gfx_lmodct[file] = ctime();
		}
		if (__gfx_lmodct[file] && (ctime()-__gfx_lmodct[file]) > 1.0)
		{
			delete __gfx_lmodct[file];
			__graphics[file] = _loadImage(file);
		}
		return __graphics[file];
	}
    else
    {
		__gfx_lastmod[file] = _flastmod(file);
        __graphics[file] = _loadImage(file);
		__gfx_lmct1[file] = ctime();
        return __graphics[file];
    }
}

var lineIntersectU = function(a,b,c,d)
{
	var desc = (d.y-c.y)*(b.x-a.x) - (d.x-c.x)*(b.y-a.y);
	if (desc < 0.0001)
		return null;
	var u = (d.x-c.x)*(a.y-c.y) - (d.y-c.y)*(a.x-c.x);
	u /= desc;
	return u;
};

var lineIntersect = function(a,b,c,d)
{
	var u = lineIntersectU(a,b,c,d);
	if (u === null)
		return null;
	return new pnt(a.x+(b.x-a.x)*u, a.y+(b.y-a.y)*u);
};

var ccvvTimeIntersect = function(ap, bp, av, bv, ar, br) // All me baby
{
	var A = ap.x-bp.x;
	var B = ap.y-bp.y;
	var C = av.x-bv.x;
	var D = av.y-bv.y;

	var _a = A*A + B*B - ar + br;
	var _b = 2.0*C*A + 2.0*D*B;
	var _c = C*C + D*D;

	var delta = _b*_b - 4.0*_a*_c;
	if (Math.abs(_a) < 0.00001 || delta < 0)
		return null;

	var t1 = (-_b + Math.sqrt(delta)) / (2.0*_a);
	var t2 = (-_b - Math.sqrt(delta)) / (2.0*_a);

	var t = Math.max(t1,t2);
	if (t > 0.0)
		return t;
	else
		return null;
};

var pntFromAngle = function(a)
{
	return new pnt(Math.cos(a), Math.sin(a));
};
var pnt = function(x,y)
{
    if (x||x===0) this.x = x; else this.x = 0.0;
    if (y||y===0) this.y = y; else this.y = 0.0;
};
pnt.prototype.clone = function() {
    return new pnt(this.x, this.y);
};
pnt.prototype.toJSON = function() {
	return "new pnt(" + this.x + "," + this.y + ")";
};
pnt.prototype.distance = function(p) {
	return this.sub(p).length();
};
pnt.prototype.sub = function(p) {
	return new pnt(this.x-p.x, this.y-p.y);
};
pnt.prototype.add = function(p) {
	return new pnt(this.x+p.x, this.y+p.y);
};
pnt.prototype.mulf = function(f) {
	return new pnt(this.x*f, this.y*f);
};
pnt.prototype.length = function() {
	return Math.sqrt(this.x*this.x+this.y*this.y);
};
pnt.prototype.norm = function() {
	var len = this.length();
	if (len < 0.000001) return new pnt(0,0);
	else return this.mulf(1.0/len);
};
pnt.prototype.rotate = function(a) {
	var ca = Math.cos(a), sa = Math.sin(a);
	return new pnt(
		this.x*ca - this.y*sa,
		this.y*ca + this.x*sa
	);
};
pnt.prototype.inBox = function(min, max) {
	return !(this.x < min.x || this.y < min.y || this.x > max.x || this.x > max.y);
};
pnt.prototype.toAngle = function(aoffset)
{
	if (this.length() < 0.01) return 0.0;
	else
	{
		var a;
		if (!aoffset) a = Math.atan2(this.y, this.x);
		else
		{
			var p = this.rotate(aoffset);
			a = Math.atan2(p.y, p.x);
		}
		if (a < 0.0) a += 2.0 * Math.PI;
		return a;
	}
};
var cam = function(p, z)
{
    if (p) this.p = p.clone(); else this.p = new pnt(0.0, 0.0);
    if (z||z===0) this.z = z; else this.z = 1.0;
};
cam.prototype.toScr = function(ip) {
    return new pnt( (ip.x - this.p.x) * this.z + (XRES/2), (ip.y - this.p.y) * this.z + (YRES/2) );
};
cam.prototype.fromScr = function(ip) {
    return new pnt( (ip.x - (XRES/2)) / this.z + this.p.x, (ip.y - (YRES/2)) / this.z + this.p.y );
};
cam.prototype.toJSON = function() {
	return "new cam(" + this.p.toJSON() + "," + this.z + ")";
};
cam.prototype.clone = function(c)
{
    return new cam(this.p, this.z);
};
function getCam()
{
    return eval(_getCam());
}
function setCam(c)
{
    _setCam(c.p.x, c.p.y, c.z);
}

function angleDiff(a,b)
{
	return Math.atan2(Math.sin(a-b), Math.cos(a-b));
}

var __obs = {};
var __cobid = 1;

// From: http://joshgertzen.com/object-oriented-super-class-method-calling-with-javascript/
function Class() { }
Class.prototype.construct = function() {};
Class.extend = function(def) {
    var classDef = function() {
      if (arguments[0] !== Class) {
		this.construct.apply(this, arguments);
	  }
    };

    var proto = new this(Class);
    var superClass = this.prototype;

    for (var n in def) {
      var item = def[n];                      
      if (typeof item === "function") item.$ = superClass;
      proto[n] = item;
    }

	proto.$ = superClass;
    classDef.prototype = proto;

    //Give this new class the same static extend method    
    classDef.extend = this.extend;      
    return classDef;
};

var __zone = {};
var __zid = 1;

var Zone = Class.extend({
	p: null,
	r: 1000.0,
	tag: null,
	id: null,
	sub: null,
	parent: null,
	className: "Zone",
	active: 0,
	clr: 0,
	zr: 15,
	
	construct: function(p, tag, r)
	{
		this.id = __zid;
		this.tag = tag;
		this.sub = [];
		if (r||r===0.0) this.r = r;
		if (p) this.p = p.clone();
		else this.p = new pnt(0,0);
		this.calcClr();
		__zid += 1;
	},
	
	calcClr: function()
	{
		var tag = this.tag;
		if (typeof tag === typeof "")
		{
			var hash = 1;
			for (var i=0; i<tag.length; i++)
			{
				hash *= 11;
				hash += tag.charCodeAt(i);
			}
			var red = ((hash*33333)%1000)/1000.0;
			var green = ((hash*331331)%1000)/1000.0;
			var blue = ((hash*317731)%1000)/1000.0;
			this.clr = rgba(red*0.5+0.5,green*0.5+0.5,blue*0.5+0.5, 0.333);
		}
	},
	
	toJSON: function()
	{
		return "new Zone(" + this.p.toJSON() + "," + JSON.stringify(this.tag) + "," + this.r + ")";
	},
	
	getPosition: function()
	{
		return this.p.clone();
	},
	getRadius: function()
	{
		return this.r;
	},
	getTag: function()
	{
		return this.tag + "";
	}
});

var __tlzone = {};

function zonesByTag(tag, zones)
{
	var o = [];
	if (zones)
	{
		var f = function(z)
		{
			if (z.tag === tag)
				o.push(z);
			for (var i=0; i<z.sub.length; i++)
				f(z.sub[i]);
		};
		if (zones.className && zones.className === "Zone")
			f(zones);
		else
			for (var i=0; i<zones.length; i++)
				f(zones[i]);
		return o;
	}
	for (var id in __zone)
		if (__zone[id].tag === tag)
			o.push(__zone[id]);
	return o;
}

function zoneActive(zones, state)
{
	for (var i=0; i<zones.length; i++)
		zones[i].active = state;
	_lzb = null; // Reset zone collisions
}

var __exzone = null;

function zoneExclusive(zone, state)
{
	if (state)
		__exzone = zone;
	else
		__exzone = null;
	_lzb = null;
}

var _lzb = null;

function drawZones()
{
	var c = getCam();
	if (_lzb !== null)
	{
		var mm1 = [ c.fromScr(new pnt(0, 0)), c.fromScr(new pnt(XRES, YRES)) ];
		if (!(mm1[0].x < _lzb[0].x || mm1[0].y < _lzb[0].y || mm1[1].x > _lzb[1].x || mm1[1].y > _lzb[1].y))
		{
			_drawZones("redraw");
			return;
		}
	}
	var mm = [ new pnt(-SYSTEM_RADIUS*1.5, -SYSTEM_RADIUS*1.5), new pnt(SYSTEM_RADIUS*1.5, SYSTEM_RADIUS*1.5) ];
	var lst = zonesInBox(mm[0], mm[1]);
	var o = [ mm[0].x, mm[0].y, mm[1].x, mm[1].y ];
	for (var i=0; i<lst.length; i++)
	{
		var p = lst[i].p;
		o.push(p.x);
		o.push(p.y);
		o.push(lst[i].r);
		o.push(__exzone===null?lst[i].active:(__exzone===lst[i]?1:0));
	}
	_drawZones(o.join(","));
	_lzb = mm;
}

function zonesInBox(min, max)
{
	var q = [ [], [] ];
	var cur = 0, nxt = 1;
	for (var id in __tlzone)
		q[cur].push(__tlzone[id]);
	var o = [];
	while (q[cur].length > 0)
	{
		q[nxt] = [];
		for (var i=0; i<q[cur].length; i++)
		{
			var z = q[cur][i];
			if ( (z.p.x+z.r*2.0) >= min.x && (z.p.y+z.r*2.0) >= min.y && (z.p.x-z.r*2.0) <= max.x && (z.p.y-z.r*2.0) <= max.y )
			{
				for (var j=0; j<z.sub.length; j++)
					q[nxt].push(z.sub[j]);
				if ( (z.p.x+z.r) >= min.x && (z.p.y+z.r) >= min.y && (z.p.x-z.r) <= max.x && (z.p.y-z.r) <= max.y )
					o.push(z);
			}
		}
		cur = 1 - cur;
		nxt = 1 - nxt;
	}
	return o;
}

function _inZone(z, p, l, r)
{
	if (z._nocheck)
		return null;
	z._l = l;
	var dist = p.distance(z.p);
	if (dist < (z.r*2.0+r))
	{
		var mind = -1;
		var ret = null;
		for (var i=0; i<z.sub.length; i++)
		{
			var r2 = _inZone(z.sub[i], p, l+1, r);
			if (r2 !== null)
			{
				if (r2[1] < mind || mind < 0)
				{
					if (ret === null || ret._l === r2[0]._l)
					{
						ret = r2[0];
						mind = r2[1];
					}
				}
			}
		}
		if (ret === null && dist < (z.r+r))
			return [z, dist];
		else if (ret)
			return [ret, mind];
		else
			return null;
	}
	return null;
}

function inZone(p, r)
{
	var radius = r?r:0.0;
	var ret = null;
	var mind = -1;
	for (var id in __tlzone)
	{
		var z = _inZone(__tlzone[id], p, 0, radius);
		if (z && z[0])
		{
			if (z[1] < mind || mind < 0)
			{
				mind = z[1];
				ret = z[0];
			}
		}
	}
	return ret;
}

function closestZone(p)
{
	var mind = -1.0;
	var closest = null;
	for (var id in __zone)
	{
		var dist = __zone[id].p.distance(p);
		if (dist < mind || mind<0)
		{
			mind = dist;
			closest = __zone[id];
		}
	}
	return closest;
}

function addZone(z)
{
	z.parent = null;
	z._nocheck = true;
	var cz = inZone(z.p);
	z._nocheck = false;
	z.zr = 15;
	if (cz !== null)
	{
		z.r = Math.min(z.r, cz.r/2.0);
		z.zr = cz.zr * 0.75;
		cz.sub.push(z);
		z.parent = cz;
	}
	else
	{
		z.parent = null;
		__tlzone[z.id] = z;
	}
	__zone[z.id] = z;
	reZone(z);
}

function moveZone(z)
{
	if (z.parent)
	{
		for (var i=0; i<z.parent.sub.length; i++)
			if (z.parent.sub[i] === z)
			{
				z.parent.sub.splice(i, 1);
				break;
			}
		z.parent = null;
	}
	else
		delete __tlzone[z.id];
	delete __zone[z.id];
	addZone(z);
}

function reZone(z)
{
	var lst = [];
	for (id in __tlzone)
		lst.push(__tlzone[id]);
	if (z.parent)
		lst = z.parent.sub;
	for (var i=0; i<lst.length; i++)
		if (lst[i] !== z)
		{
			var d = z.p.distance(lst[i].p);
			if (d < z.r && d >= lst[i].r)
			{
				var olen = lst.length;
				moveZone(lst[i]);
				if (lst.length !== olen)
					i --;
			}
		}
}

var __planet = {};
var __plid = 1;

var Planet = Class.extend({
	p: null,
	r: 100.0,
	a: 0.0,
	res: 300,
	seed: 1,
	smoothf: 18,
	id: null,
	className: "Planet",
	
	construct: function(p, r, a, res, seed, smoothf)
	{
		this.id = __plid;
		this.p = p?p.clone():new pnt(0.0);
		if (r||r===0) this.r = r;
		if (a||a===0) this.a = a;
		if (res||a===0) this.res = res;
		if (typeof seed === typeof "")
		{
			var hash = 1;
			for (var i=0; i<seed.length; i++)
			{
				hash *= 3;
				hash += seed.charCodeAt(i);
			}
			seed = hash;
		}
		if (seed||seed===0) this.seed = seed;
		if (smoothf||smoothf===0) this.smoothf = smoothf;
		__plid += 1;
	},
	
	distanceTo: function(p)
	{
		return p.distance(this.p) - this.heightAt(p);
	},
	
	heightAt: function(p)
	{
		return _planetDistance(this.id, p.x, p.y);
	},
	
	update: function()
	{
		_setPlanet([this.id,this.p.x,this.p.y,this.r,this.a,this.res,this.seed,this.smoothf].join(","));
	},
	toJSON: function()
	{
		return "new Planet(" + this.p.toJSON() + "," + this.r + "," + this.a + "," + this.res + "," + this.seed + "," + this.smoothf + ")";
	}
});

function addPlanet(po)
{
	(__planet[po.id] = po).update();
}

// Game Object
var GObject = Class.extend({

    p: null, v: null,
    r: null,
    id: null,
	a: null, w: null,
	e: 1.0, u: 0.0,
	mass: 1.0,
	cgroup: 0,
	in_links: null,
	out_links: null,
	pa_jump: false,
	cenabled: true,
	
	// Collision/physics
	cobj: null,
	
    active: true,
	isFixedZ: false,
	isFixed: false,
	isBackground: false,
	isObject: true,
    className: "GObject",
	planet: null,

    construct: function (p, r, a, olinks_tmp, plid)
    {
		this.olinks_tmp = olinks_tmp?olinks_tmp:[];
		this.planet = (plid||plid===0)?__planet[plid]:null;
		this.r = (r||r===0)?r:(this.r?this.r:15.0);
		this.out_links = [];
		this.in_links = [];
		
        this.p = p?p.clone():getCam().p;
		this.v = new pnt(0.0);
		
		this.a = (a||a===0)?a:0.0;
		this.w = 0.0;
		
        this.id = __cobid;
        __cobid += 1;
    },
	
	onScreen: function(_bfr)
	{
		var bfr = (_bfr?_bfr:0) + this.r;
		var sp = getCam().toScr(this.getPosition());
		if (sp.x < -bfr || sp.y < -bfr || sp.x > (XRES+bfr) || sp.y > (YRES+bfr))
			return false;
		return true;
	},

	getActualRadius: function (c)
	{
		if (!c) c = getCam();
		if (this.isFixedZ && (IN_EDITOR === false || this.editorFixedZ))
			return this.getRadius()/c.z;
		else
			return this.getRadius();
	},
	toString: function ()
	{
		return this.className+","+this.id+","+this.p.x+","+this.p.y+","+this.r+","+this.a+","+(this.active?1:0)+","+(this._isFixedZ?1:0);
	},
	toJSON: function ()
	{
		var olinks = [];
		for (var i=0; i<this.out_links.length; i++)
			olinks.push(this.out_links[i].id);
		return "new " + this.className + "(" + this.p.toJSON() + "," + this.r + "," + this.a + ",[" + olinks.join(",") + "]" + "," + (this.planet!==null?this.planet.id:null) + ")";
	},
	setAngle: function ( a ) // Will recreate cobj
	{
		this.a = a;
		this.pa_jump = true;
	},
	getAngle: function ()
	{
		return this.a;
	},
	setMass: function ( m ) // Will recreate cobj
	{
		this.mass = m;
		this.pa_jump = true;
	},
	getMass: function ()
	{
		return this.mass;
	},
    setRadius: function ( r ) // Will recreate cobj
    {
		this.r = r;
		this.pa_jump = true;
    },
    getRadius: function ()
    {
		return this.r;
    },
    setPosition: function ( p ) // Will recreate cobj
    {
		this.p = p.clone();
		this.pa_jump = true;
    },
    getPosition: function ()
    {
		return this.p.clone();
    },
    setActive: function (active)
    {
        this.active = active;
    },
	setVelocity: function(v)
	{
		this.v = v.clone();
	},
	getVelocity: function()
	{
		return this.v.clone();
	},
	setAngVelocity: function(w)
	{
		this.w = w;
	},
	getAngVelocity: function()
	{
		return w;
	},
	addAngVelocity: function(dw)
	{
		this.w += dw;
	},
	addVelocity: function(dv)
	{
		this.v = new pnt(this.v.x + dv.x, this.v.y + dv.y);
	},
	moveTowards: function(p, max_speed, accel)
	{
		var c = getCam();
		var dv = p.sub(this.getPosition()).norm().mulf(accel);
		this.addVelocity(dv.mulf(1.0/c.z))
		this.capVelocity(max_speed/c.z);
	},
	moveTowardsAndStop: function(p, max_speed, accel, stime)
	{
		var c = getCam();
		var dist = p.sub(this.getPosition());
		var v0 = this.getVelocity();
		var a = dist.sub(v0.mulf(stime)).mulf(1.0/(0.5*stime*stime));
		this.addVelocity(a.mulf((1.0/FPS)*(1.0/c.z)));
		this.capVelocity(max_speed/c.z);
	},
	rotateTowardsAndStop: function(ta, stime)
	{
		this.addAngVelocity(angleDiff(ta, this.a)/stime);
	},
	capVelocity: function(max_speed)
	{
		if (this.v.length() > max_speed)
			this.v = this.v.norm().mulf(max_speed);
	},
	/*rotateTowards: function(ta, max_speed, accel)
	{
		if (Math.abs(ta-this.a) > Math.PI)
		{
			if (ta > 0)
				ta = -Math.PI - (Math.PI-ta);
			else
				ta = Math.PI - (-Math.PI-ta);
		}
		if (Math.abs(ta-this.a) > 0.0001)
		{
			var dw = (ta-this.a)/Math.abs(ta-this.a)*(accel/FPS);
			this.addAngVelocity(dw)
			this.capAngVelocity(max_speed);
		}
	},*/
	capAngVelocity: function(max_speed)
	{
		if (Math.abs(this.w) > max_speed)
			this.w = Math.abs(this.w)/this.w * max_speed;
	},
	dampenVelocity: function(factor, time) // If factor is 0.9 and time is 1.0, velocity will drop by 10% after 1s
	{
		var df = Math.pow(factor, time/FPS);
		this.v.x *= df;
		this.v.y *= df;
	},
	dampenAngVelocity: function(factor, time)
	{
		var df = Math.pow(factor, time/FPS);
		this.w *= df;
	},
	addLink: function(obj)
	{
		if (this.findLink(obj) === -1)
		{
			this.out_links.push(obj);
			obj.in_links.push(this);
		}
	},
	findLink: function(obj)
	{
		for (var i=0; i<this.out_links.length; i++)
			if (this.out_links[i] === obj)
				return i;
		return -1;
	},
	removeLink: function(obj)
	{
		var i;
		if ( (i=this.findLink(obj)) >= 0 )
		{
			this.out_links.splice(i, 1);
			for (var j=0; j<obj.in_links.length; j++)
				if (obj.in_links[j] === this)
				{
					obj.in_links.splice(j, 1);
					break;
				}
		}
	},
	_getPhysUpdate: function() // Don't call
	{
		if (this.cobj !== null)
		{
			var lst = _getCObj(this.cobj).split(",");
			this.p = new pnt(parseFloat(lst[0]), parseFloat(lst[1]));
			this.v = new pnt(parseFloat(lst[2]), parseFloat(lst[3]));
			this.a = parseFloat(lst[4]);
			this.w = parseFloat(lst[5]);
		}
	},
	_sendPhysUpdate: function() // Don't call
	{
		if (this.cobj === null)
		{
			this.cobj = this.getCollisionObj();
			__cobjs[this.cobj] = this;
			this.pa_jump = false;
		}
			
		if (this.cobj !== null)
		{
			if (this.pa_jump === true || this.cenabled === false)
			{
				delete __cobjs[this.cobj];
				_deleteCObj(this.cobj);
				this.cobj = this.getCollisionObj();
				__cobjs[this.cobj] = this;
				this.pa_jump = false;
			}		
		}
		if (!this.isFixed)
		{
			this.p.x += this.v.x * 1.0/FPS;
			this.p.y += this.v.y * 1.0/FPS;
			this.a += this.w * 1.0/FPS;
			if (this.cobj !== null)
			{
				_updateCObj(this.cobj, this.p.x, this.p.y, this.a, this.cgroup);
			}
		}
	},
	collisionObjectCircle: function()
	{
		return this._collisionObject("___null");
	},
	collisionObjectImage: function(img_file)
	{
		return this._collisionObject(img_file);
	},
	_collisionObject: function(img_file)
	{
		if (this.cenabled === false)
			return null;
		this.pa_jump = true;
		var imgid = -1;
		if (img_file !== "___null")
			imgid = loadImage(img_file);
		var r = _newCObj([imgid, this.cgroup, this.mass, this.e, this.u, this.getActualRadius(), this.p.x, this.p.y, this.a, this.v.x, this.v.y, this.w, (this.isFixed===true?1:0)].join(","));
		return r;
	},
	setGhost: function(flag)
	{
		this.cenabled = flag;
	},
	getGhost: function()
	{
		return this.cenabled;
	},
	setCGroup: function(cgroup)
	{
		this.cgroup = cgroup;
	},
	getCGroup: function()
	{
		return this.cgroup;
	},

    // Extendable
    init: function ()
    {
    },
    editorRender: function (c)
    {
        var p = c.toScr(this.getPosition());
        var r = this.getRadius();
		if (this.isFixedZ === false)	r *= c.z;
        drawImage(loadImage("mob.png"), p.x-r, p.y-r, r*2.0);
    },
    gameRender: function (c)
    {
        var p = c.toScr(this.getPosition());
        var r = this.getRadius();
		if (this.isFixedZ === false)	r *= c.z;
        drawImage(loadImage("mob.png"), p.x-r, p.y-r, r*2.0);
    },
    update: function ( dt )
    {
    },
	getCollisionObj: function()
	{
		return null;
	},
	canSee: function (ob)
	{
		var rayc = fireRay(this.getPosition(), ob.getPosition(), this.cgroup);
		if (rayc && rayc.obj)
		{
			if (rayc.obj.id === ob.id)
			{
				return true;
			}
		}
		return false;
	},
	
	avoidObject: function(ob, min_dist, max_speed, accel)
	{
		var dist = ob.p.distance(this.p);
		if (dist < min_dist)
		{
			var f = 1.0 - (dist/min_dist);
			var dv = this.p.sub(ob.p).norm().mulf(min_dist*f);
			this.moveTowards(ob.p.add(dv), max_speed, accel);
		}
	},
	
	ob_tracking: null,
	trackObject: function(ob, btime, max_dist, min_dist, max_speed, accel, stime, rotspeed)
	{
		var rs = 0.0;
		if (rotspeed) rs = rotspeed;
		if (this.ob_tracking === null)
		{
			this.ob_tracking = {
				ob: ob,
				pnts: [ob.getPosition()]
			};
		}
		if (this.ob_tracking.ob.id !== ob.id)
		{
			this.ob_tracking = null;
			return max_dist;
		}
		else
		{
			var pnts = this.ob_tracking.pnts;
			var t = pnts[0].clone();
			if (this.canSee(ob))
			{
				pnts.push(ob.getPosition());
				if (pnts.length > FPS*btime)
					pnts.splice(0, 1);
				else
					t = null;
			}
			if (t && t.distance(this.p) < max_dist)
			{
				if (this.p.distance(t) < (max_dist * 0.125 + min_dist * (1-0.125)))
				{
					var dv = this.p.sub(t);
					var ang = dv.toAngle() + Math.PI / 2.0;
					this.addVelocity(pntFromAngle(ang).mulf(rs));
				}
				var dv = this.p.sub(t).norm().mulf(min_dist);
				this.moveTowardsAndStop(t.add(dv), max_speed, accel, stime);
				return t.distance(this.p);
			}
			else
				return max_dist;
		}
	}
});
registerObjectType("GObject", "__root");

var Dynamic = GObject.extend({
	isFixed: false,
});
registerObjectType("Dynamic", "GObject");

var Fixed = GObject.extend({
	isFixed: true,
});
registerObjectType("Fixed", "GObject");

function _sendAllPhysUpdates()
{
	var c = getCam();
	for (var id in __obs)
	{
		if (__obs[id].p.distance(c.p)*c.z < 1000 || __obs[id].alwaysActive === true)
		{
			__obs[id].update(1.0/FPS);
			if (__obs[id])
			{
				if (__obs[id].isFixed === false)
					__obs[id]._sendPhysUpdate();
				else if (__obs[id].cobj === null)
					__obs[id].cobj = __obs[id].getCollisionObj();
			}
		}
		else if (__obs[id].isFixed === false && __obs[id].cobj !== null)
		{
			delete __cobjs[__obs[id].cobj];
			_deleteCObj(__obs[id].cobj);
			__obs[id].cobj = null;
		}
	}
}

function _getAllPhysUpdates()
{
	for (var id in __obs)
		__obs[id]._getPhysUpdate();
}

function fireRay(start, end, cgroup)
{
	var lst = eval(_fireRay([start.x, start.y, end.x, end.y, cgroup].join(",")));
	if (!lst) return null;
	var ret = { obj: __cobjs[lst[0]], hit: null, norm: null };
	ret.hit = new pnt(lst[1], lst[2]);
	ret.norm = new pnt(lst[3], lst[4]);
	return ret;
}

var __cobjs = {};
var __dobjs = {};
var __fobjs = {};

function _collisions(list)
{
	for (var i=0; i<list.length; i++)
	{
		var set = {};
		var a = list[i][0] !== "0"?__cobjs[list[i][0]]:null;
		var b = list[i][1] !== "0"?__cobjs[list[i][1]]:null;
		set[a?a:'static'] = true;
		set[b?b:'static'] = true;
		var im = new pnt(list[i][2], list[i][3]);
		etrigger("any_collision", -1, {
			set: set,
			obja: a?a:'static',
			objb: b?b:'static',
			im: im.clone()
		});
		if (a) etrigger("collision", a.id, { obj: b, im: im.clone() });
		if (b) etrigger("collision", b.id, { obj: a, im: im.clone() });
	}
}

function addObject ( ob )
{
    if (!__obs[ob.id])
    {
        __obs[ob.id] = ob;
		if (__obs[ob.id].isFixed)
			__fobjs[ob.id] = ob;
		else
			__dobjs[ob.id] = ob;
        //_registerObject(ob.id, ob.className);
        ob.setRadius(ob.r);
        ob.setPosition(ob.p);
        ob.setActive(ob.active);
		ob.init();
    }
}

function removeObject ( ob )
{
	if (__obs[ob.id])
	{
		while (ob.out_links.length > 0)
			ob.removeLink(ob.out_links[0]);
		for (var i=0; i<ob.in_links.length; i++)
			__obs[ob.in_links[i].id].removeLink(ob);
		if (__obs[ob.id].cobj)
		{
			delete __cobjs[__obs[ob.id].cobj];
			_deleteCObj(__obs[ob.id].cobj);
		}
		if (__obs[ob.id].isFixed)
			delete __fobjs[ob.id];
		else
			delete __dobjs[ob.id];
		delete __obs[ob.id];
		ob.id = -1;
	}
}

function removePlanet ( pl )
{
	if (__planet[pl.id])
	{
		for (var id in __obs)
			if (__obs[id].planet === pl)
				__obs[id].planet = null;
		_deletePlanet(pl.id);
		delete __planet[pl.id];
	}
}

function _render ( c )
{
	for (var id in __obs)
	{
		var ob = __obs[id];
		if (!ob.isBackground) continue;
		
		if (IN_EDITOR === false)
			ob.gameRender(c);
		else
			ob.editorRender(c);
	}
	for (var id in __obs)
	{
		var ob = __obs[id];
		if (ob.isBackground === true) continue;
		
		if (IN_EDITOR === false)
			ob.gameRender(c);
		else
			ob.editorRender(c);
	}
}

function _update ( dt )
{
/*
	for (var id in __obs)
	{
		var ob = __obs[id];
		if (IN_EDITOR === false)
			ob.update(dt);
	}
*/
}

function getObjByClass( className )
{
	var ret = [];
	for (var id in __obs)
	{
		if (__obs[id].className === className)
			ret.push(__obs[id]);
	}
	return ret;
}

function closestObjectByClass( p, className, exclude )
{
	var ob = {};
	var obs = getObjByClass(className);
	for (var i=0; i<obs.length; i++)
		ob[obs[i].id] = obs[i];
	return closestObject(p, exclude, ob);
}

function closestObjectByCGroup( p, cgroup, exclude )
{
	var mind = -1, min = null;
	for (var id in __dobjs)
	{
		var ob = __dobjs[id];
		if (ob.cgroup === cgroup && (!exclude || exclude.id !== ob.id))
		{
			var dist = ob.p.distance(p);
			if (mind === -1 || dist < mind)
			{
				mind = dist;
				min  = ob;
			}
		}
	}
	return min;
}

function dynamicObjectList()
{
	var ret = [];
	for (var id in __dobjs)
		ret.push(__dobjs[id]);
	return ret;
}

function closestObject( p, exclude, __ob )
{
	var exset = {};
	if (exclude)
	{
		if (exclude.isObject)
			exset[exclude.id] = true;
		else
		{
			for (var i=0; i<exclude.length; i++)
				exset[exclude[i].id] = true;
		}
	}
	var ob = __ob?__ob:__obs;
	var closest = null;
	var cdist = -1;
	for (var id in ob)
	{
		if (exset[id])
			continue;
		var op = ob[id].getPosition();
		var dist = (op.x-p.x)*(op.x-p.x) + (op.y-p.y)*(op.y-p.y);
		if (cdist === -1 || cdist > dist)
		{
			cdist = dist;
			closest = ob[id];
		}
	}
	return closest;
}
function closestDynamicObject( p, exclude )
{
	return closestObject(p, exclude, __dobjs);
}
function closestFixedObject( p, exclude )
{
	return closestObject(p, exclude, __fobjs);
}

function closestPlanet( p )
{
	var closest = null;
	var cdist = -1;
	for (var id in __planet)
	{
		var op = __planet[id].p;
		var dist = (op.x-p.x)*(op.x-p.x) + (op.y-p.y)*(op.y-p.y);
		if (cdist === -1 || cdist > dist)
		{
			cdist = dist;
			closest = __planet[id];
		}
	}
	return closest;
}

// For engine use
function _closestObject(x,y)
{
	var p = new pnt(x,y);
	var o = closestObject(p);
	if (o === null)
		return ""
	else
		return ob.toString();
}
function _objectByID(id)
{
	return __obs[id];
}

// JSON stringify		https://github.com/douglascrockford/JSON-js/blob/master/json2.js    //
//////////////////////////////////////////////////////////////////////////////////////////////

var JSON;
if (!JSON) {
    JSON = {};
}
(function () {
    'use strict';

    function f(n) {
        return n < 10 ? '0' + n : n;
    }

    if (typeof Date.prototype.toJSON !== 'function') {

        Date.prototype.toJSON = function (key) {

            return isFinite(this.valueOf())
                ? this.getUTCFullYear()     + '-' +
                    f(this.getUTCMonth() + 1) + '-' +
                    f(this.getUTCDate())      + 'T' +
                    f(this.getUTCHours())     + ':' +
                    f(this.getUTCMinutes())   + ':' +
                    f(this.getUTCSeconds())   + 'Z'
                : null;
        };

        String.prototype.toJSON      =
            Number.prototype.toJSON  =
            Boolean.prototype.toJSON = function (key) {
                return this.valueOf();
            };
    }

    var cx = /[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
        escapable = /[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
        gap,
        indent,
        meta = {    // table of character substitutions
            '\b': '\\b',
            '\t': '\\t',
            '\n': '\\n',
            '\f': '\\f',
            '\r': '\\r',
            '"' : '\\"',
            '\\': '\\\\'
        },
        rep;


    function quote(string) {

        escapable.lastIndex = 0;
        return escapable.test(string) ? '"' + string.replace(escapable, function (a) {
            var c = meta[a];
            return typeof c === 'string'
                ? c
                : '\\u' + ('0000' + a.charCodeAt(0).toString(16)).slice(-4);
        }) + '"' : '"' + string + '"';
    }

    function str(key, holder) {

        var i,          // The loop counter.
            k,          // The member key.
            v,          // The member value.
            length,
            mind = gap,
            partial,
            value = holder[key];

        if (value && typeof value === 'object' &&
                typeof value.toJSON === 'function') {
            value = value.toJSON(key);
        }

        if (typeof rep === 'function') {
            value = rep.call(holder, key, value);
        }

        switch (typeof value) {
        case 'string':
            return quote(value);

        case 'number':

			return isFinite(value) ? String(value) : 'null';

        case 'boolean':
        case 'null':

            return String(value);

        case 'object':

            if (!value) {
                return 'null';
            }

            gap += indent;
            partial = [];

            if (Object.prototype.toString.apply(value) === '[object Array]') {

                length = value.length;
                for (i = 0; i < length; i += 1) {
                    partial[i] = str(i, value) || 'null';
                }

                v = partial.length === 0
                    ? '[]'
                    : gap
                    ? '[\n' + gap + partial.join(',\n' + gap) + '\n' + mind + ']'
                    : '[' + partial.join(',') + ']';
                gap = mind;
                return v;
            }

            if (rep && typeof rep === 'object') {
                length = rep.length;
                for (i = 0; i < length; i += 1) {
                    if (typeof rep[i] === 'string') {
                        k = rep[i];
                        v = str(k, value);
                        if (v) {
                            partial.push(quote(k) + (gap ? ': ' : ':') + v);
                        }
                    }
                }
            } else {

                for (k in value) {
                    //if (Object.prototype.hasOwnProperty.call(value, k)) {
                        v = str(k, value);
                        if (v) {
                            partial.push(quote(k) + (gap ? ': ' : ':') + v);
                        }
                    //}
                }
            }

            v = partial.length === 0
                ? '{}'
                : gap
                ? '{\n' + gap + partial.join(',\n' + gap) + '\n' + mind + '}'
                : '{' + partial.join(',') + '}';
            gap = mind;
            return v;
        }
		
		return '';
    }

    if (typeof JSON.stringify !== 'function') {
        JSON.stringify = function (value, replacer, space) {

            var i;
            gap = '';
            indent = '';

            if (typeof space === 'number') {
                for (i = 0; i < space; i += 1) {
                    indent += ' ';
                }

            } else if (typeof space === 'string') {
                indent = space;
            }

            return str('', {'': value});
        };
    }
}());

//////////////////////////////////////////
	
function serialize(ob)
{
	return JSON.stringify(ob);
}

function deserialize (str)
{
	return eval(str);
}

function getConfig(key)
{
	return deserialize(_getConfig(0, key));
}

function setConfig(key, value)
{
	_setConfig(0, key, serialize(value));
}

function rgb(r,g,b)
{
	return rgba(r,g,b,1.0);
}

function _loadZones()
{
	var x = deserialize(_getConfig(1069, "zones"));
	if (x)
	{
		__zone = {};
		__tlzone = {};
		__zid = 1;
		for (var id in x[0])
		{
			addZone(eval(x[0][id]));
		}
	}
}

function _loadObjects()
{
	__fobjs = {};
	__dobjs = {};
	var x = deserialize(_getConfig(1069, "objects"));
	if (x)
	{
		__obs = {};
		for (var id in x[0])
		{
			var s = x[0][id];
			var n = eval(s);
			n.id = parseInt(id);
			__obs[n.id] = n;
			if (n.isFixed)
				__fobjs[n.id] = n;
			else
				__dobjs[n.id] = n;
			n.init();
		}
		for (var id in __obs)
		{
			var o = __obs[id];
			for (var i=0; i<o.olinks_tmp.length; i++)
			{
				var o2 = __obs[o.olinks_tmp[i]];
				o.addLink(o2);
			}
			o.olinks_tmp = [];
		}
		__cobid = x[1];
	}
	_loadZones();
}

function _loadPlanets()
{
	var x = deserialize(_getConfig(1069, "planets"));
	if (x)
	{
		__planet = {};
		for (var id in x[0])
		{
			var s = x[0][id];
			var n = eval(s);
			n.id = parseInt(id);
			__planet[n.id] = n;
			n.update();
		}
		__plid = x[1];
	}
}

ebind("camz_change", global_event, function(e){
	for (var id in __obs)
	{
		var ob = __obs[id];
		if (ob.isFixedZ === true)
		{
			var v = ob.getVelocity();
			v.x = v.x * e.oldz / getCam().z;
			v.y = v.y * e.oldz / getCam().z;
			ob.setVelocity(v);
			ob.pa_jump = true;
		}
	}
});

function drawPolygon(p, scale, rot, points, c, z)
{
	var out = [];
	for (var i=0; i<points.length; i+=2)
	{
		var p1 = points[i+1].mulf(scale*(z?z:1.0)).rotate(rot).add(p);
		if (c) p1 = c.toScr(p1);
		out.push(points[i+0]);
		out.push(p1.x);
		out.push(p1.y);
	}
	_drawPolygon(out.join(","));
}

function addParticle(p, v, sz, clr, life)
{
	_addParticle([p.x, p.y, v.x/FPS, v.y/FPS, sz, clr, life].join(","));
}